// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/actuator.hpp"



actuator::actuator( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    pclk("pclk"),
    presetn("presetn"),
    paddr("paddr"),
    psel("psel"),
    penable("penable"),
    pwrite("pwrite"),
    pwdata("pwdata"),
    pready("pready"),
    prdata("prdata"),
    actuator_open("actuator_open"),
    actuator_close("actuator_close"),
    actuator_threshold("actuator_threshold"),
    actuator_open_reg("actuator_open_reg"),
    actuator_close_reg("actuator_close_reg"),
    actuator_threshold_reg("actuator_threshold_reg")
{
    pready.initialize( false );
    prdata.initialize( 0UL );
    actuator_open.initialize( false );
    actuator_close.initialize( false );
    actuator_threshold.initialize( uint16_t(0U) );
    actuator_open_reg = false;
    actuator_close_reg = false;
    actuator_threshold_reg = uint16_t(0U);

    SC_METHOD( process );
    sensitive << pclk.pos();
}

actuator::~actuator()
{}

void actuator::start_of_simulation()
{
    actuator_open = false;
    actuator_close = false;
    actuator_threshold = uint16_t(0U);
    actuator_open_reg = false;
    actuator_close_reg = false;
    actuator_threshold_reg = uint16_t(0U);
}


void actuator::process()
{
    actuator_open = actuator_open_reg.read();
    actuator_close = actuator_close_reg.read();
    actuator_threshold = actuator_threshold_reg.read();
    if (penable.read())
    {
        actuator_open_reg = pwdata.read() & 1UL;
        actuator_close_reg = pwdata.read() >> 8UL & 1UL;
        actuator_threshold_reg = pwdata.read() >> 16L & 65535UL;
        pready = true;
    }
    else
    {
        pready = false;
    }
}



